import { inject as w, defineComponent as d, openBlock as R, createElementBlock as m, renderSlot as g, createTextVNode as U, computed as I, createCommentVNode as A, unref as y, ref as p } from "vue";
const P = Symbol("fusionAuth"), f = () => {
  const r = w(P);
  if (!r)
    throw new Error(
      "No FusionAuth instance found. Did you forget to call Vue.use(FusionAuthVuePlugin)?"
    );
  return r;
}, E = /* @__PURE__ */ d({
  __name: "FusionAuthLoginButton",
  props: {
    state: {}
  },
  setup(r) {
    const t = f(), e = r;
    function n() {
      t.login(e.state);
    }
    return (o, s) => (R(), m("button", {
      class: "login-button",
      onClick: s[0] || (s[0] = (u) => n())
    }, [
      g(o.$slots, "default", {}, () => [
        U("Login")
      ], !0)
    ]));
  }
});
const v = (r, t) => {
  const e = r.__vccOpts || r;
  for (const [n, o] of t)
    e[n] = o;
  return e;
}, L = /* @__PURE__ */ v(E, [["__scopeId", "data-v-e1ac1678"]]), k = /* @__PURE__ */ d({
  __name: "FusionAuthLogoutButton",
  setup(r) {
    const t = f();
    function e() {
      t.logout();
    }
    return (n, o) => (R(), m("button", {
      class: "logout-button",
      onClick: o[0] || (o[0] = (s) => e())
    }, [
      g(n.$slots, "default", {}, () => [
        U("Logout")
      ], !0)
    ]));
  }
});
const T = /* @__PURE__ */ v(k, [["__scopeId", "data-v-fb8f3354"]]), x = /* @__PURE__ */ d({
  __name: "FusionAuthRegisterButton",
  props: {
    state: {}
  },
  setup(r) {
    const t = f(), e = r;
    function n() {
      t.register(e.state);
    }
    return (o, s) => (R(), m("button", {
      class: "register-button",
      onClick: s[0] || (s[0] = (u) => n())
    }, [
      g(o.$slots, "default", {}, () => [
        U("Register")
      ], !0)
    ]));
  }
});
const b = /* @__PURE__ */ v(x, [["__scopeId", "data-v-6adc2447"]]), S = /* @__PURE__ */ d({
  __name: "RequireAuth",
  props: {
    withRole: {}
  },
  setup(r) {
    const t = r, { isLoggedIn: e, userInfo: n } = f(), o = I(() => {
      var c;
      if (!e.value || n.value === null)
        return !1;
      if (!t.withRole)
        return !0;
      const s = Array.isArray(t.withRole) ? t.withRole : [t.withRole], u = ((c = n.value) == null ? void 0 : c.roles) ?? [], a = e.value === !0, l = u.some((_) => s.includes(_));
      return a && l;
    });
    return (s, u) => o.value ? g(s.$slots, "default", { key: 0 }) : A("", !0);
  }
}), F = /* @__PURE__ */ d({
  __name: "RequireAnonymous",
  setup(r) {
    const { isLoggedIn: t } = f();
    return (e, n) => y(t) ? A("", !0) : g(e.$slots, "default", { key: 0 });
  }
}), $ = /* @__PURE__ */ Object.freeze(/* @__PURE__ */ Object.defineProperty({
  __proto__: null,
  FusionAuthLoginButton: L,
  FusionAuthLogoutButton: T,
  FusionAuthRegisterButton: b,
  RequireAnonymous: F,
  RequireAuth: S
}, Symbol.toStringTag, { value: "Module" }));
var V = Object.defineProperty, B = (r, t, e) => t in r ? V(r, t, { enumerable: !0, configurable: !0, writable: !0, value: e }) : r[t] = e, i = (r, t, e) => (B(r, typeof t != "symbol" ? t + "" : t, e), e);
class C {
  constructor(t) {
    i(this, "serverUrl"), i(this, "clientId"), i(this, "redirectUri"), i(this, "scope"), i(this, "mePath"), i(this, "loginPath"), i(this, "registerPath"), i(this, "logoutPath"), i(this, "tokenRefreshPath"), this.serverUrl = t.serverUrl, this.clientId = t.clientId, this.redirectUri = t.redirectUri, this.scope = t.scope, this.mePath = t.mePath ?? "/app/me", this.loginPath = t.loginPath ?? "/app/login", this.registerPath = t.registerPath ?? "/app/register", this.logoutPath = t.logoutPath ?? "/app/logout", this.tokenRefreshPath = t.tokenRefreshPath ?? "/app/refresh";
  }
  getMeUrl() {
    return this.generateUrl(this.mePath);
  }
  getLoginUrl(t) {
    return this.generateUrl(this.loginPath, {
      client_id: this.clientId,
      redirect_uri: this.redirectUri,
      scope: this.scope,
      state: t
    });
  }
  getRegisterUrl(t) {
    return this.generateUrl(this.registerPath, {
      client_id: this.clientId,
      redirect_uri: this.redirectUri,
      scope: this.scope,
      state: t
    });
  }
  getLogoutUrl() {
    return this.generateUrl(this.logoutPath, {
      client_id: this.clientId,
      post_logout_redirect_uri: this.redirectUri
    });
  }
  getTokenRefreshUrl() {
    return this.generateUrl(this.tokenRefreshPath, {
      client_id: this.clientId
    });
  }
  generateUrl(t, e) {
    const n = new URL(this.serverUrl);
    if (n.pathname = t, e) {
      const o = this.generateURLSearchParams(e);
      n.search = o.toString();
    }
    return n;
  }
  generateURLSearchParams(t) {
    const e = new URLSearchParams();
    return Object.entries(t).forEach(([n, o]) => {
      o && e.append(n, o);
    }), e;
  }
}
class H {
  constructor() {
    i(this, "REDIRECT_VALUE", "fa-sdk-redirect-value");
  }
  handlePreRedirect(t) {
    const e = `${this.generateRandomString()}:${t ?? ""}`;
    localStorage.setItem(this.REDIRECT_VALUE, e);
  }
  handlePostRedirect(t) {
    const e = this.stateValue ?? void 0;
    t == null || t(e), localStorage.removeItem(this.REDIRECT_VALUE);
  }
  get didRedirect() {
    return !!localStorage.getItem(this.REDIRECT_VALUE);
  }
  get stateValue() {
    const t = localStorage.getItem(this.REDIRECT_VALUE);
    if (!t)
      return null;
    const [, ...e] = t.split(":");
    return e.join(":");
  }
  generateRandomString() {
    const t = new Uint32Array(28);
    return window.crypto.getRandomValues(t), Array.from(
      t,
      (e) => ("0" + e.toString(16)).substring(-2)
    ).join("");
  }
}
function q(r = "app.at_exp") {
  const t = document.cookie.split("; ").map((n) => n.split("=")).find(([n]) => n === r), e = t == null ? void 0 : t[1];
  return e ? parseInt(e) * 1e3 : null;
}
class j {
  constructor(t) {
    i(this, "config"), i(this, "urlHelper"), i(this, "redirectHelper", new H()), i(this, "tokenExpirationTimeout"), this.config = t, this.urlHelper = new C({
      serverUrl: t.serverUrl,
      clientId: t.clientId,
      redirectUri: t.redirectUri,
      scope: t.scope,
      mePath: t.mePath,
      loginPath: t.loginPath,
      registerPath: t.registerPath,
      logoutPath: t.logoutPath,
      tokenRefreshPath: t.tokenRefreshPath
    }), this.scheduleTokenExpiration();
  }
  startLogin(t) {
    this.redirectHelper.handlePreRedirect(t), window.location.assign(this.urlHelper.getLoginUrl(t));
  }
  startRegister(t) {
    this.redirectHelper.handlePreRedirect(t), window.location.assign(this.urlHelper.getRegisterUrl(t));
  }
  startLogout() {
    window.location.assign(this.urlHelper.getLogoutUrl());
  }
  async fetchUserInfo() {
    const t = await fetch(this.urlHelper.getMeUrl(), {
      credentials: "include"
    });
    if (!t.ok)
      throw new Error(
        `Unable to fetch userInfo in fusionauth. Request failed with status code ${t == null ? void 0 : t.status}`
      );
    return await t.json();
  }
  async refreshToken() {
    const t = await fetch(this.urlHelper.getTokenRefreshUrl(), {
      method: "POST",
      credentials: "include",
      headers: {
        "Content-Type": "text/plain"
      }
    });
    if (!(t.status >= 200 && t.status < 300)) {
      const e = await (t == null ? void 0 : t.text()) || "Error refreshing access token in fusionauth";
      throw new Error(e);
    }
    return this.scheduleTokenExpiration(), t;
  }
  initAutoRefresh() {
    const t = this.at_exp, e = this.config.autoRefreshSecondsBeforeExpiry ?? 10;
    if (!t)
      return;
    const n = e * 1e3, o = (/* @__PURE__ */ new Date()).getTime(), s = t - n, u = Math.max(s - o, 0);
    return setTimeout(async () => {
      var a, l;
      try {
        await this.refreshToken(), this.initAutoRefresh();
      } catch (c) {
        (l = (a = this.config).onAutoRefreshFailure) == null || l.call(a, c);
      }
    }, u);
  }
  handlePostRedirect(t) {
    this.isLoggedIn && this.redirectHelper.didRedirect && this.redirectHelper.handlePostRedirect(t);
  }
  get isLoggedIn() {
    return this.at_exp ? this.at_exp > (/* @__PURE__ */ new Date()).getTime() : !1;
  }
  /** The moment of access token expiration in milliseconds since epoch. */
  get at_exp() {
    return q(
      this.config.accessTokenExpireCookieName
    );
  }
  /** Schedules `onTokenExpiration` at moment of access token expiration. */
  scheduleTokenExpiration() {
    clearTimeout(this.tokenExpirationTimeout);
    const t = this.at_exp ?? -1, e = (/* @__PURE__ */ new Date()).getTime(), n = t - e;
    n > 0 && (this.tokenExpirationTimeout = setTimeout(
      this.config.onTokenExpiration,
      n
    ));
  }
}
const D = (r) => {
  const t = new j({
    ...r,
    onTokenExpiration: () => {
      e.value = !1;
    }
  }), e = p(t.isLoggedIn), n = p(null), o = p(!1), s = p(null);
  async function u() {
    o.value = !0, s.value = null;
    try {
      return n.value = await t.fetchUserInfo(), n.value;
    } catch (h) {
      s.value = h;
    } finally {
      o.value = !1;
    }
  }
  async function a() {
    return await t.refreshToken();
  }
  function l(h) {
    t.startLogin(h);
  }
  function c(h) {
    t.startRegister(h);
  }
  function _() {
    t.startLogout();
  }
  return r.shouldAutoFetchUserInfo && t.isLoggedIn === !0 && u(), r.shouldAutoRefresh && t.isLoggedIn === !0 && t.initAutoRefresh(), t.handlePostRedirect(r.onRedirect), {
    isLoggedIn: e,
    userInfo: n,
    getUserInfo: u,
    isGettingUserInfo: o,
    error: s,
    login: l,
    register: c,
    logout: _,
    refreshToken: a,
    initAutoRefresh: t.initAutoRefresh
  };
}, M = {
  install(r, t) {
    if (!t.clientId)
      throw new Error("clientId is required");
    if (!t.serverUrl)
      throw new Error("serverUrl is required");
    if (!t.redirectUri)
      throw new Error("redirectUri is required");
    r.provide(P, D(t)), Object.entries($).forEach(([e, n]) => {
      r.component(e, n);
    });
  }
};
export {
  L as FusionAuthLoginButton,
  T as FusionAuthLogoutButton,
  b as FusionAuthRegisterButton,
  F as RequireAnonymous,
  S as RequireAuth,
  M as default,
  f as useFusionAuth
};
